﻿Option Strict On
Option Infer On

Imports System.IO

Friend Class Way
    Private world As World
    Private m_segments() As WaySegment

    Friend ReadOnly Property segments As WaySegment()
        Get
            Return m_segments
        End Get
    End Property

    Sub New(path As String, w As World)
        world = w
        load(path)
    End Sub

    Private Sub load(path As String)
        Dim f = IO.Path.Combine(path, "map.td2")
        Dim fs = File.Open(f, FileMode.Open, FileAccess.Read)
        Dim vals(Convert.ToInt32(fs.Length / 9) - 1) As MetaData
        Dim br As New BinaryReader(fs)
        For i = 0 To vals.Length - 1
            vals(i) = New MetaData
            vals(i).pX = br.ReadInt32
            vals(i).pY = br.ReadInt32
            vals(i).extra = br.ReadByte()
        Next
        br.Close()
        br.Dispose()
        fs.Close()
        fs.Dispose()
        Dim segs(vals.Length - 2) As WaySegment
        Dim allSegments() = WaySegment.GetAllWaySegments
        For i = 1 To vals.Length - 1
            Dim p1 As New PointF(vals(i - 1).pX, vals(i - 1).pY)
            Dim p2 As New PointF(vals(i).pX, vals(i).pY)
            If i = vals.Length - 1 Then
                segs(i - 1) = New EndWaySegment(Me, world, p1, p2)
            Else
                segs(i - 1) = DirectCast(Activator.CreateInstance(allSegments(vals(i).extra), {Me, world, p1, p2}), WaySegment)
            End If
        Next
        m_segments = segs
    End Sub

    Private Structure MetaData
        Friend pX As Integer
        Friend pY As Integer
        Friend extra As Byte
    End Structure
End Class